/*
* Copyright (C) 2010 Daniele E. Domenichelli <daniele.domenichelli@gmail.com>
*
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This library is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this library; if not, write to the Free Software
* Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#ifndef KTELEPATHYACCOUNTSWIDGET_P_H
#define KTELEPATHYACCOUNTSWIDGET_P_H

#include "ktelepathyaccountswidget.h"

class KTelepathyAccountsWidgetPrivate
{
    Q_DECLARE_PUBLIC(KTelepathyAccountsWidget)

    protected:
        KTelepathyAccountsWidget * const q_ptr;

    public:
        KTelepathyAccountsWidgetPrivate(KTelepathyAccountsWidget* parent);
        virtual ~KTelepathyAccountsWidgetPrivate();

        void __k__displayModeAccounts();
        void __k__displayModeContacts();
        void __k__displayModeMetaContacts();

        Tp::ConnectionPresenceType currentConnectionPresence(Nepomuk::IMAccount account);
        Tp::ConnectionPresenceType currentConnectionPresence(Nepomuk::PersonContact contact);
        Tp::ConnectionPresenceType currentConnectionPresence(Nepomuk::Person metacontact);

        QString connectionPresenceIconName(Tp::ConnectionPresenceType status);
        QIcon& connectionPresenceIcon(Tp::ConnectionPresenceType status);
        bool isAllowed(Tp::ConnectionPresenceType status); //TODO change name?
        void removeAllItems(); //TODO find a better way on update
        void startQuery(); //TODO change name?

        Nepomuk::PersonContact mePersonContact;

        KTelepathyAccountsWidget::DisplayMode displayMode;
        KTelepathyAccountsWidget::ConnectionPresences connectionPresences;

        void test(); //TODO remove
        void __k__onCurrentIndexChanged(int index); //TODO remove
};

#endif // KTELEPATHYACCOUNTSWIDGET_P_H
